; JU+TE TINY ES4.0
; Monitorerweiterung BITMAN

; reass. V.Pohlers 05.01.2022

; Programm BITMAN
; Die Befehle B und < sind ntzlich zur Erstellung von
; Zeichengeneratoren und laufen ab jeder %XXX0 Adresse im Bereich
; %8000-FFFF. Sie knnen z.B. mit LC000 geladen werden und sind 0060
; Byte lang.


		cpu	z8601
		assume RP:0C0h		; prevent register optimization thru AS
		
; AS-Funktionen
hi	function x,(x>>8)&255
lo	function x, x&255
;

byte_10	equ	10h			; Hilfsregister
byte_12	equ	12h			; Hilfsregister
word_1A	equ	1Ah			; Zeiger auf das bearbeitete Byte im Speicher

; ES 40
CHAROUT	equ	818h
RWCONT	equ	0C91h
PCAS	equ	0C9Bh
ADRE	equ	0CA9h

		org 0c000h

;------------------------------------------------------------------------------
; Baaaa listet Speicherinhalt binr auf, ein 0-Bit ist ein .
; (Punkt) und ein 1-Bit ein * (Mal). Das Bit 7 steht links. spc
;------------------------------------------------------------------------------

		align 10h
		db  'B'			; Kdo 'B'
		db  95h			; Kennbytes
		db  95h
		db  95h
		dw	28h		; Anz Bytes
		dw	0EC5Dh		; PSum
;
;;		assume RP:10h
mon_bin:	call	ADRE
bin1:		ld	R5, #'<'
		call	PCAS		; Ausg. R5 und Adr
		lde	R0, @RR10
		ld	R1, #8
bin2:		ld	R5, #'*'
		rl	byte_10
		jr	C, bin3
		ld	R5, #'.'
bin3:		call	CHAROUT
		djnz	R1, bin2
		incw	word_1A
		call	RWCONT
		jr	Z, bin1
		ret
	

		org	0c030h

;------------------------------------------------------------------------------
; <aaaa. *.*.*.*.	beschreibt den Speicher	binr, siehe B,	gibt die
; nchste	Adresse	aus, wenn alle 8 Bit korrekt (also . oder *) sind.
;------------------------------------------------------------------------------

		align 10h
		db '<'
		db  95h
		db  95h
		db  95h
		dw	28h
		dw	0ECA0h
;
;;		assume RP:10h
mon_binwrite:	call	ADRE
		ld	R1, #8
binwrite1:	lde	R2, @RR14
		inc	R15
		cp	byte_12, #'.'
		jr	Z, binwrite2
		cp	byte_12, #'*'
		jr	NZ, binwrite3
		scf
binwrite2:	rlc	byte_10
		djnz	R1, binwrite1
		lde	@RR10, R0
		incw	word_1A
		ld	R5, #'<'
		jp	PCAS		; Ausg. R5 und Adr
binwrite3:	ret

		end
