; JU+TE TINY ES4.0
; Monitorerweiterung KCTRANS

; reass. V.Pohlers 05.01.2022

; Mit dem Programm KCTRANS kann man Programme im KC-Kassettenformat
; laden und speichern. Es ist eine Befehlserweiterung fr den MON,
; wird mit LF100 geladen und stellt die Befehle G und P bereit.
; Achtung! Wenn man das Programm mal ab irgendeiner anderen Adresse
; geladen hat, sollte man es dort wieder lschen (mit dem F-Befehl),
; da ansonsten die Befehle P und G nicht funktionieren, auch wenn das
; Programm noch ab der richtigen Adresse (F100) geladen wird (mit
; Batteriesttze bleibt ja alles erhalten).

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		cpu	z8601
		assume RP:0C0h		; prevent register optimization thru AS
		
; AS-Funktionen
hi	function x,(x>>8)&255
lo	function x, x&255
;
;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; segment INTMEM
word_20	equ 20h
byte_22	equ 22h
byte_23	equ 23h
byte_24	equ 24h
byte_25	equ 25h
byte_40	equ 40h
byte_5E	equ 5Eh				; sub_F366:loc_F3B7w ...
byte_5F	equ 5Fh
byte_60	equ 60h				; sub_F366+58w
byte_6D	equ 6Dh				; sub_F366:loc_F3D6r

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

p3 equ	3				; Port 3

rp equ	0FDh				; Register pointer

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; ES 40
CHAROUT	equ	818h
KEY	equ	81Bh
PRISTRI	equ	82Dh
HTA16	equ	0C69h
HTA8	equ	0C72h
PMON	equ	0AF7h
ADRE	equ	0CA9h


		org	0f100h

;------------------------------------------------------------------------------
; Paaaa aaaa name	Speichern eines	Programms im KC-Format ab
; Adresse	aaaa mit aaaa Byte Lnge auf Kassette und Namen	name.
;------------------------------------------------------------------------------
		
		align 10h
		db 'P'
		db  95h
		db  95h
		db  95h
		dw 2F8h
		dw 3DFBh
mon_p:		cp	R12, #hi(mon_p)
		jr	NZ, mon_p1
		cp	R13, #lo(mon_p)
		jr	Z, mon_p2
mon_p1:		call	PRISTRI
		db "Falsche Ladeadresse! Verschieben mit",0Dh
		db "Malta F100 0300",0Dh,0
		ret
;
mon_p2:		call	ADRE
		ld	word_20, R12
		ld	word_20+1, R13
		call	ADRE
		ld	byte_22, R12
		ld	byte_23, R13
		ld	byte_24, R14
		ld	byte_25, R15
		call	sub_F252
		ld	R9, #0
		call	HTA8
		jp	PMON
		
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 

;------------------------------------------------------------------------------
; Gaaaa Laden eines Programms im KC-Format von Kassette
; in den Speicher ab Adresse aaaa. Meldung wie bei Befehl L. Danach
; kann das Programm mit dem S-Befehl abgespeichert werden. Ab 0F580h
; steht im Speicher der Name des Programms (Anzeigen mit AF580) und
; auf 0F591h/2 steht die alte Startadresse im L/H-Format (L-Byte, dann
; H-Byte). Diese Werte stehen im Kassettenpuffer des ES4.0, werden
; also beim nchsten S- oder L-Befehl berschrieben.
;------------------------------------------------------------------------------

		align 10h
		db 'G'
		db  95h
		db  95h
		db  95h
		dw 288h
		dw 6D11h
mon_g:		cp	R12, #hi(mon_g)
		jr	NZ, mon_p1
		cp	R13, #lo(mon_g)
		jr	NZ, mon_p1
		call	ADRE
		ld	word_20, R12
		ld	word_20+1, R13
		call	sub_F2F4
		ld	R9, byte_23
		ld	R8, byte_22
		call	HTA16
		ld	R5, #' '
		call	CHAROUT
		ld	R9, byte_24
		call	HTA8
		jp	PMON

		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 
		db 0AFh ; 

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

		org	0f200h

sub_F200:	ld	R4, #0
		ld	R5, R8
loc_F204:	decw	RR4
		jr	NZ, loc_F204
		xor	p3, #40h	; Port 3
		ld	R5, R8
loc_F20D:	decw	RR4
		jr	NZ, loc_F20D
		xor	p3, #40h	; Port 3
		ret
		
		db 0FFh
		db 0FFh
		db 0FFh

sub_F218:	ld	R8, #94h
		call	sub_F200
		ld	R10, #8
loc_F21F:	rr	R9
		ld	R8, #4Ah
		jr	C, loc_F227
		ld	R8, #25h
loc_F227:	call	sub_F200
		djnz	R10, loc_F21F
		ret

		db 0FFh
		db 0FFh
		db 0FFh

sub_F230:	ld	R8, #4Ah
		call	sub_F200
		decw	RR12
		jr	NZ, sub_F230
		ld	R9, R6
		call	sub_F218
		ld	R13, #80h
		ld	R7, #0
loc_F242:	lde	R9, @RR0
		incw	RR0
		call	sub_F218
		add	R7, R9
		djnz	R13, loc_F242
		ld	R9, R7
		jr	sub_F218
		
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

;Speichern
sub_F252:	push	rp		; Register pointer
		srp	#20h
		add	R3, R1
		adc	R2, R0
		nop
		nop
		ld	byte_40, R1
		ld	R1, R0
		ld	R0, R2
		ld	R2, R3
		ld	R3, R0
		ld	R0, byte_40
		di
		srp	#40h
		ld	R0, #-0Bh
		ld	p3, #0FCh	; Port 3
		ld	R1, #80h
		ld	R2, byte_24
		ld	R3, byte_25
		ld	R4, #0Bh
loc_F278:	lde	R5, @RR2
		lde	@RR0, R5
		inc	R1
		inc	R3
		djnz	R4, loc_F278
loc_F280:	lde	@RR0, R4
		inc	R1
		jr	NZ, loc_F280
		ld	R5, #2
		ld	R1, #90h
		lde	@RR0, R5
		inc	R1
		ld	R5, #20h
		ld	R4, #4
loc_F290:	ldei	@RR0, @R5
		djnz	R4, loc_F290
		ld	R1, #80h
		ld	R6, #1
		ld	R12, #20h
		call	sub_F230
		ld	R0, word_20+1
		ld	R1, word_20
		ld	R2, byte_23
		ld	R3, byte_22
loc_F2A5:	inc	R6
		ld	R4, R2
		ld	R5, R3
		sub	R5, R1
		sbc	R4, R0
		jr	NC, loc_F2B4
		pop	rp		; Register pointer
		ei
		ret
loc_F2B4:	sub	R5, #80h
		sbc	R4, R12
		jr	NC, loc_F2BD
		ld	R6, #0FFh
loc_F2BD:	ld	R13, #0A0h
		call	sub_F230
		jr	loc_F2A5

		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Laden
sub_F2F4:	clr	byte_24
		di
		push	rp		; Register pointer
		srp	#40h
		ld	R0, #0F5h
		ld	R1, #80h
		ld	R6, #0
		call	sub_F366
		jr	C, loc_F311
		ld	R0, word_20
		ld	R1, word_20+1
loc_F30A:	call	sub_F366
		jr	C, loc_F311
		jr	Z, loc_F30A
loc_F311:	sbc	byte_24, byte_24
		ei
		ld	R0, #0F5h
		ld	R1, #91h
		ld	R2, #44h
		ld	R3, #4
loc_F31D:	ldei	@R2, @RR0
		djnz	R3, loc_F31D
		sub	R6, R4
		sbc	R7, R5
		ld	byte_22, R7
		ld	byte_23, R6
		nop
		nop
		pop	rp		; Register pointer
		ret
sub_F32E:	ld	R11, #0FFh
loc_F330:	ld	R12, #0FAh
loc_F332:	inc	R11
		ld	R8, p3		; Port 3
		and	R8, #1
		cp	R8, R4
		jr	Z, loc_F330
		inc	R12
		jr	NZ, loc_F332
		ld	R4, R8
		ret
sub_F342:	call	sub_F32E
		cp	R11, R14
		jr	C, locret_F34B
		cp	R15, R11
locret_F34B:	ret
		
		db 0FFh
		db 0FFh

sub_F34E:	call	sub_F32E
		call	sub_F32E
sub_F354:	ld	R10, #8
loc_F356:	call	sub_F32E
		call	sub_F32E
		cp	R11, #16h
		ccf
		rrc	R9
		djnz	R10, loc_F356
		ret
		
		db 0FFh

sub_F366:	ld	R13, #50h
		ld	R14, #16h
		ld	R15, #2Ah
loc_F36C:	call	sub_F342
		jr	C, sub_F366
		djnz	R13, loc_F36C
		ld	R14, #2Ah
		ld	R15, #6Ah
loc_F377:	call	sub_F342
		jr	C, loc_F377
		call	sub_F342
		jr	C, sub_F366
		call	sub_F354
		ld	byte_5F, R9
		ld	R13, #80h
		ld	R7, #0
		nop
loc_F38B:	call	sub_F34E
		lde	@RR0, R9
		incw	RR0
		add	R7, R9
		djnz	R13, loc_F38B
		call	sub_F34E
		cp	R7, R9
		jr	NZ, loc_F3AB
		inc	R6
		cp	R6, byte_5F
		jr	NZ, loc_F3A5
		rcf
		ret
loc_F3A5:	inc	byte_5F
		jr	Z, loc_F3DD
		dec	R6
loc_F3AB:	sub	R1, #80h
		sbc	R0, #0
loc_F3B1:	ld	byte_60, #20h
loc_F3B4:	ld	byte_5E, #36h
loc_F3B7:	dec	byte_5E
		jr	NZ, loc_F3B7
		xor	p3, #40h	; Port 3
		dec	byte_60
		jr	NZ, loc_F3B4
		call	KEY
		ld	byte_5E, #36h
loc_F3C8:	dec	byte_5E
		jr	NZ, loc_F3C8
		or	p3, #40h	; Port 3
		cp	byte_6D, #'B'
		jr	NZ, loc_F3D6
		scf
		ret
loc_F3D6:	cp	byte_6D, #'C'
		jr	Z, sub_F366
		jr	loc_F3B1
loc_F3DD:	inc	byte_5F
		rcf
		ret
		
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh
		db 0FFh

		end
